#define INFO_BUFFER_SIZE 32767 

#include "mainimage.h"
#include <QFileDialog>
#include <QGraphicsScene>
#include <QGraphicsProxyWidget>



mainimage::mainimage(QWidget *parent)
	: QDialog(parent)
{
 scene = new QGraphicsScene;
 image = new QImage;
 setupUi(this);
 graphicsView->setScene(scene); 
}

mainimage::~mainimage()
{

}

void mainimage::showEvent(QShowEvent *event)
{	 
	GrabWindows(L"grabWindow",compname);
	graphicsView->fitInView(scene->sceneRect(),Qt::IgnoreAspectRatio);	 
} 

void mainimage::resizeEvent(QResizeEvent *event)
{
	graphicsView->fitInView(scene->sceneRect(),Qt::IgnoreAspectRatio);	 
}

void mainimage::on_pushButton_clicked()
{

QString fileName = QFileDialog::getOpenFileName(this,
     tr(" "), QDir::currentPath(), tr("Image Files (*.png *.jpg *.bmp)")); 

 if (!fileName.isEmpty()) 

 {
	 image->load(fileName);  
	 scene->clear();
     QGraphicsPixmapItem * item = scene->addPixmap(QPixmap::fromImage(*image)); 
 }

}

void mainimage::on_pushButton_2_clicked()
{
graphicsView->resetTransform();
}

void mainimage::on_pushButton_3_clicked()
{
graphicsView->fitInView(scene->sceneRect(),Qt::IgnoreAspectRatio);
}

void mainimage::on_pushButton_4_clicked()
{

	QBuffer buffer(&photo);
	buffer.open(QIODevice::WriteOnly);
    image->save(&buffer,"JPG");

}

void mainimage::on_pushButton_5_clicked()
{
QString fileName = QFileDialog::getSaveFileName(this,tr(" "), QDir::currentPath(),tr("Image Files (*.png)")); 
image->save(fileName,"PNG");
}

TCHAR mainmsg[0x1000];
TCHAR mainimgbuf[INFO_BUFFER_SIZE];

void mainimage::GrabWindows(LPTSTR command,LPTSTR compname)
{

	QString read;
	bool fSuccess; 
	HANDLE hPipe; 
	int countblock;
	TCHAR lpszPipename[MAX_PATH];
	DWORD cbRead, cbWritten, dwMode; 
	ZeroMemory( &mainmsg, sizeof(mainmsg));
	wsprintf( lpszPipename,L"%s%s%s",L"\\\\",compname,L"\\pipe\\my_pipe_server_");
	while (1) 
	{ 
		hPipe = CreateFile( 
			lpszPipename,   // pipe name 
			GENERIC_READ |  // read and write access 
			GENERIC_WRITE, 
			0,              // no sharing 
			NULL,           // default security attributes
			OPEN_EXISTING,  // opens existing pipe 
			0,              // default attributes 
			NULL);          // no template file 


		if (hPipe != INVALID_HANDLE_VALUE) 
			break; 

		if (GetLastError() != ERROR_PIPE_BUSY) 
		{
			CloseHandle(hPipe); 	
			MessageBox(NULL,L"   ",lpszPipename,MB_ICONSTOP);
			return;
		}

		if (!WaitNamedPipe(lpszPipename, 20000)) 
		{
			CloseHandle(hPipe); 	
			return;
		}		 
	}

	dwMode = PIPE_READMODE_MESSAGE; 

	fSuccess=SetNamedPipeHandleState(hPipe, &dwMode,NULL, NULL);    
	if (!fSuccess) 
	{
		CloseHandle(hPipe); 	
		return;
	}

	fSuccess=WriteFile(hPipe,command,(lstrlen(command)+1)*sizeof(TCHAR),&cbWritten,NULL);
	if (!fSuccess) 
	{
		MessageBox(NULL,L"   ",L"ERROR",MB_ICONSTOP);
	}

	do 
	{ 

		fSuccess = ReadFile( 
			hPipe,    // pipe handle 
			mainmsg,    // buffer to receive reply 
			sizeof(mainmsg),  // size of buffer 
			&cbRead,  // number of bytes read 
			NULL);    // not overlapped 

		if (! fSuccess && GetLastError() != ERROR_MORE_DATA) 
			break; 

	} 
	while (!fSuccess);  // repeat loop if ERROR_MORE_DATA 


	countblock=_wtoi(mainmsg);

	for (int i=0;i<countblock;i++)		
	{ 
		DWORD dwErr = GetLastError();
		if ( dwErr == ERROR_NO_DATA)
			break;

		fSuccess = ReadFile( 
			hPipe,    // pipe handle 
			mainimgbuf,    // buffer to receive reply 
			sizeof(mainimgbuf),  // size of buffer 
			&cbRead,  // number of bytes read 
			NULL);    // not overlapped 

		read=read+QString::fromStdWString(mainimgbuf);

		ZeroMemory(mainimgbuf, sizeof(mainimgbuf));

		if (! fSuccess && GetLastError() != ERROR_MORE_DATA) 
			break; 
	} 

	CloseHandle(hPipe);
	QByteArray MyImg=QByteArray::fromHex(read.toAscii());		
	photo=qUncompress(MyImg);
	image->loadFromData(photo);
	scene->clear();
	scene->addPixmap(QPixmap::fromImage(*image));

}


void mainimage::on_graphicsView_customContextMenuRequested(QPoint)
{
   QMenu menu(this);
   QAction *action1 = menu.addAction("");
   QAction *triggered = menu.exec(QCursor::pos());
   if (triggered == action1)
   {
	 scene->clear();	
	 image->fill(qRgb(255, 255, 255));
	 GrabWindows(L"grabWindow",compname);

   }
}
