#include <pdh.h>
#include <PDHMsg.h>
#include "my_process.h"
#include "remote_assistant.h"

#pragma comment(lib, "pdh.lib")

PDH_STATUS Status;
WCHAR COUNTER_OBJECT[80];
WCHAR COUNTER_OBJECT_[80];
WCHAR COUNTER_NAME_[80];
WCHAR PID_OBJECT[80];
HQUERY Query = NULL;
DWORD dwCounterListSize = 0;
DWORD dwInstanceListSize = 0,CounterType;
LPWSTR pTemp = NULL;
HCOUNTER Counter,Counter_PID;
PDH_FMT_COUNTERVALUE DisplayValue;
PDH_FMT_COUNTERVALUE_ITEM *pItems = NULL;
PDH_COUNTER_PATH_ELEMENTS pdh_elm;
QStringList my_process;

get_process::get_process(QWidget *parent)
: QDialog(parent)
{
setupUi(this);
ZeroMemory(&compname, sizeof(compname));
startTimer(1000);
}

get_process::~get_process()
{
	
	//GlobalFree(Counter);
	//GlobalFree(Counter_PID);
	
	PdhRemoveCounter(Counter);	
	PdhRemoveCounter(Counter_PID);	

	if (Query) 
		PdhCloseQuery(Query);

}


void get_process::doinit()
{
	LPWSTR pwsCounterListBuffer = NULL;
	WCHAR CounterPathBuffer[PDH_MAX_COUNTER_PATH];
	WCHAR PIDPathBuffer[PDH_MAX_COUNTER_PATH];
	LPWSTR pwsInstanceListBuffer = NULL;

	Status = PdhOpenQuery(NULL, NULL, &Query);

	if (Status != ERROR_SUCCESS) 
	{
		if (Query) 
			PdhCloseQuery(Query);
		return;
	}


	DWORD dwSize = sizeof(COUNTER_OBJECT);
	Status=PdhLookupPerfNameByIndex(compname,230,COUNTER_OBJECT,&dwSize);
	if(Status != ERROR_SUCCESS)
	{
		if (Query) 
			PdhCloseQuery(Query);
		return;

	}

	
	dwSize = sizeof(PID_OBJECT);
	Status=PdhLookupPerfNameByIndex(compname,784,PID_OBJECT,&dwSize);
	if(Status != ERROR_SUCCESS)
	{
		if (Query) 
			PdhCloseQuery(Query);
		return;

	}


	dwSize = sizeof(COUNTER_OBJECT_);
	Status=PdhLookupPerfNameByIndex(compname,238,COUNTER_OBJECT_,&dwSize);
	if(Status != ERROR_SUCCESS)
	{
		if (Query) 
			PdhCloseQuery(Query);
		return;

	}

	dwSize = sizeof(COUNTER_NAME_);
	Status=PdhLookupPerfNameByIndex(compname,6,COUNTER_NAME_,&dwSize);
	if(Status != ERROR_SUCCESS)
	{
		if (Query) 
			PdhCloseQuery(Query);
		return;

	}
	

memset(&pdh_elm,0,sizeof(pdh_elm));

pdh_elm.szMachineName    = compname;
pdh_elm.szObjectName     = COUNTER_OBJECT_;
pdh_elm.szInstanceName   = L"_Total";
pdh_elm.szParentInstance = NULL;
pdh_elm.dwInstanceIndex  = (DWORD)-1;
pdh_elm.szCounterName    = COUNTER_NAME_;


dwSize = sizeof(CounterPathBuffer);
Status=PdhMakeCounterPath(&pdh_elm,CounterPathBuffer,&dwSize,0); 

 if(Status != ERROR_SUCCESS)
{
	if (Query) 
		PdhCloseQuery(Query);
	return;

}


	dwCounterListSize = 0;
	dwInstanceListSize = 0;

	if (pTemp != NULL) 
		pTemp=NULL;


	Status = PdhEnumObjectItems(
		NULL,                   // real-time source
		compname,                  
		COUNTER_OBJECT,         // object to enumerate
		pwsCounterListBuffer,   // pass NULL and 0
		&dwCounterListSize,     // to get required buffer size
		pwsInstanceListBuffer, 
		&dwInstanceListSize, 
		PERF_DETAIL_ADVANCED,     // counter detail level
		0); 


	if (Status == PDH_MORE_DATA) 
	{
		pwsCounterListBuffer = (LPWSTR)malloc(dwCounterListSize * sizeof(WCHAR));
		pwsInstanceListBuffer = (LPWSTR)malloc(dwInstanceListSize * sizeof(WCHAR));

		if (NULL != pwsCounterListBuffer && NULL != pwsInstanceListBuffer) 
		{
			Status = PdhEnumObjectItems(
				NULL,                   // real-time source
				compname,              
				COUNTER_OBJECT,         // object to enumerate
				pwsCounterListBuffer, 
				&dwCounterListSize,
				pwsInstanceListBuffer, 
				&dwInstanceListSize, 
				PERF_DETAIL_ADVANCED,     // counter detail level
				0); 

			if (Status == ERROR_SUCCESS) 
			{
				int countprocess=0;
				my_process.clear();
				QString tempstr;
				int count=1;
				for (pTemp = pwsInstanceListBuffer; *pTemp != 0; pTemp += wcslen(pTemp)+1) 
				{					
					my_process<<(QString::fromWCharArray(pTemp));
					countprocess++;
				}
				qSort(my_process.begin(),my_process.end());

				tableWidget->setColumnCount(2); // 
				tableWidget->setRowCount(countprocess); //

                QStringList mycolumns;
				mycolumns<<" "<<"PID";
				tableWidget->setHorizontalHeaderLabels(mycolumns);
				tableWidget->setSortingEnabled(false);
				tableWidget->verticalHeader()->hide();

				for (int i=0;i<my_process.size();i++)
				{
					tempstr=my_process.at(i);
			     if (i>0)
				 {
                  if (tempstr==my_process.at(i-1))
				  {   
					  tempstr=tempstr+"#"+QString::number(count);
				      count++;
				  }
				  else
					  count=1;
				 }
				 
				 memset(&pdh_elm,0,sizeof(pdh_elm));
				 pdh_elm.szMachineName    = compname;
				 pdh_elm.szObjectName     = COUNTER_OBJECT;
				 pdh_elm.szInstanceName   = (LPWSTR) tempstr.utf16();
				 pdh_elm.szParentInstance = NULL;
				 pdh_elm.dwInstanceIndex  = (DWORD)-1;
				 pdh_elm.szCounterName    = PID_OBJECT;

				 dwSize = sizeof(PIDPathBuffer);
				 Status=PdhMakeCounterPath(&pdh_elm,PIDPathBuffer,&dwSize,0); 

				 if(Status != ERROR_SUCCESS)
					{
						if (Query) 
							PdhCloseQuery(Query);
						return;

					}

				 Status = PdhAddCounter(Query,PIDPathBuffer,0,&Counter_PID);


				 if (Status != ERROR_SUCCESS) 
					{
						if (Query) 
							PdhCloseQuery(Query);
						return;
					}


				 if(PdhCollectQueryData(Query) != ERROR_SUCCESS)
					{
						if (Query) 
						PdhCloseQuery(Query);
						return;  
					}

				 PdhCollectQueryData(Query);

		        Status = PdhGetFormattedCounterValue(Counter_PID,PDH_FMT_DOUBLE,&CounterType,&DisplayValue);

				if(Status == ERROR_SUCCESS)
				{
					
					QString PID = QString::number(DisplayValue.doubleValue);;
					QTableWidgetItem *newItem = new QTableWidgetItem(PID);
					tableWidget->setItem(i, 1, newItem);
				}

				
				QTableWidgetItem *newItem = new QTableWidgetItem(tempstr);
				tableWidget->setItem(i, 0, newItem);

				}

                tableWidget->setSortingEnabled(true);
				label->setText(". : "+QString::number(countprocess));
			}
			else 
			{

				label->setText("PdhEnumObjectItems   %0x%x. "+Status);
			}
		}
		else 
		{
			label->setText("   ");
			Status = ERROR_OUTOFMEMORY;
		}


	}
	else
	{
		label->setText("nPdhEnumObjectItems   0x%x. "+Status);
	}


	Status = PdhAddCounter(Query,CounterPathBuffer,0,&Counter);

	if (Status != ERROR_SUCCESS) 
	{
		if (Query) 
			PdhCloseQuery(Query);
		return;
	}


	//label->setText(QString::fromWCharArray(CounterPathBuffer));

	if(PdhCollectQueryData(Query) != ERROR_SUCCESS)
	{
		if (Query) 
			PdhCloseQuery(Query);
		return;  

	}

	if (pwsCounterListBuffer != NULL) 
		free (pwsCounterListBuffer);

	if (pwsInstanceListBuffer != NULL) 
		free (pwsInstanceListBuffer);

      
}


void get_process::timerEvent(QTimerEvent *event)
{
	//Sleep(1000);

	PdhCollectQueryData(Query);
	Status = PdhGetFormattedCounterValue(Counter,PDH_FMT_DOUBLE,&CounterType,&DisplayValue);

	if(Status == ERROR_SUCCESS)
		label_3->setText(QString::number(DisplayValue.doubleValue));

}


void get_process::on_pushButton_clicked()
{
int id_proc = tableWidget->item(tableWidget->currentItem()->row(),tableWidget->model()->columnCount()-1)->data(2).toLongLong();
process_pid=QString::number(id_proc);
process_name = tableWidget->item(tableWidget->currentItem()->row(),tableWidget->model()->columnCount()-2)->data(2).toString();
this->close();
}