#include "remote_process.h"
#include <QMenu>


get_remote_process::get_remote_process(QWidget *parent): QDialog(parent)
{
	setupUi(this);    
}


get_remote_process::~get_remote_process()
{
}

void get_remote_process::showEvent(QShowEvent *event)
{	 
RemoteProcess(L"GetRemoteProcess",compname);
} 

void get_remote_process::SetCommand(LPTSTR command,LPTSTR compname)
{
	bool fSuccess; 
	HANDLE hPipe; 
	TCHAR lpszPipename[MAX_PATH];
	DWORD cbRead, cbWritten, dwMode; 
	TCHAR msg[0x1000];
	ZeroMemory( &msg, sizeof(msg));
	wsprintf( lpszPipename,L"%s%s%s",L"\\\\",compname,L"\\pipe\\my_pipe_server_");
	while (1) 
	{ 
		hPipe = CreateFile( 
			lpszPipename,   // pipe name 
			GENERIC_READ |  // read and write access 
			GENERIC_WRITE, 
			0,              // no sharing 
			NULL,           // default security attributes
			OPEN_EXISTING,  // opens existing pipe 
			0,              // default attributes 
			NULL);          // no template file 


		if (hPipe != INVALID_HANDLE_VALUE) 
			break; 

		if (GetLastError() != ERROR_PIPE_BUSY) 
		{
			CloseHandle(hPipe); 	
			MessageBox(NULL,L"   ",lpszPipename,MB_ICONSTOP);
			return;
		}

		if (!WaitNamedPipe(lpszPipename, 20000)) 
		{
			CloseHandle(hPipe); 	
			return;
		}		 
	}

	dwMode = PIPE_READMODE_MESSAGE; 

	fSuccess=SetNamedPipeHandleState(hPipe, &dwMode,NULL, NULL);    
	if (!fSuccess) 
	{
		CloseHandle(hPipe); 	
		return;
	}

	fSuccess=WriteFile(hPipe,command,(lstrlen(command)+1)*sizeof(TCHAR),&cbWritten,NULL);
	if (!fSuccess) 
	{
		MessageBox(NULL,L"   ",L"ERROR",MB_ICONSTOP);
	}

	do 
	{ 
		fSuccess = ReadFile( 
			hPipe,    // pipe handle 
			msg,    // buffer to receive reply 
			sizeof(msg),  // size of buffer 
			&cbRead,  // number of bytes read 
			NULL);    // not overlapped 

		if (! fSuccess && GetLastError() != ERROR_MORE_DATA) 
			break; 

	} 
	while (!fSuccess);  // repeat loop if ERROR_MORE_DATA 
	CloseHandle(hPipe); 
    label->setText(QString::fromStdWString(msg));

}

void get_remote_process::on_tableWidget_customContextMenuRequested(QPoint)
{
	QMenu menu(this);
	QAction *action1 = menu.addAction(" ");
	QAction *action2 = menu.addAction(" ");
	
	QAction *triggered = menu.exec(QCursor::pos());

	if (triggered == action1)
	{
int id_proc = tableWidget->item(tableWidget->currentItem()->row(),tableWidget->model()->columnCount()-2)->data(2).toLongLong();
QString command;
command="del_proc@"+QString::number(id_proc);
TCHAR mycommand[255];
wsprintf(mycommand,L"%s",command.utf16());
SetCommand(mycommand,compname);
RemoteProcess(L"GetRemoteProcess",compname);

	}

	else
		if (triggered == action2)
		{
         RemoteProcess(L"GetRemoteProcess",compname);
		}

}


void get_remote_process::RemoteProcess(LPTSTR command,LPTSTR compname)
{	
	int row=0,column=0;
	QStringList ProcessList;
	TCHAR mainmsg[0x1000];	
	QString read;
	bool fSuccess; 
	HANDLE hPipe; 
	int countblock;
	TCHAR lpszPipename[MAX_PATH];
	DWORD cbRead, cbWritten, dwMode; 
	ZeroMemory( &mainmsg, sizeof(mainmsg));
	wsprintf( lpszPipename,L"%s%s%s",L"\\\\",compname,L"\\pipe\\my_pipe_server_");
	while (1) 
	{ 
		hPipe = CreateFile( 
			lpszPipename,   // pipe name 
			GENERIC_READ |  // read and write access 
			GENERIC_WRITE, 
			0,              // no sharing 
			NULL,           // default security attributes
			OPEN_EXISTING,  // opens existing pipe 
			0,              // default attributes 
			NULL);          // no template file 


		if (hPipe != INVALID_HANDLE_VALUE) 
			break; 

		if (GetLastError() != ERROR_PIPE_BUSY) 
		{
			CloseHandle(hPipe); 	
			MessageBox(NULL,L"   ",lpszPipename,MB_ICONSTOP);
			return;
		}

		if (!WaitNamedPipe(lpszPipename, 20000)) 
		{
			CloseHandle(hPipe); 	
			return;
		}		 
	}

	dwMode = PIPE_READMODE_MESSAGE; 

	fSuccess=SetNamedPipeHandleState(hPipe, &dwMode,NULL, NULL);    
	if (!fSuccess) 
	{
		CloseHandle(hPipe); 	
		return;
	}

	fSuccess=WriteFile(hPipe,command,(lstrlen(command)+1)*sizeof(TCHAR),&cbWritten,NULL);
	if (!fSuccess) 
	{
		MessageBox(NULL,L"   ",L"ERROR",MB_ICONSTOP);
	}


	do 
	{ 

		fSuccess = ReadFile( 
			hPipe,    // pipe handle 
			&mainmsg,    // buffer to receive reply 
			sizeof (mainmsg),  // size of buffer 
			&cbRead,  // number of bytes read 
			NULL);    // not overlapped 

		if (! fSuccess && GetLastError() != ERROR_MORE_DATA) 
			break; 

	} 
	while (!fSuccess);  // repeat loop if ERROR_MORE_DATA 


	myreport remproc;
	ZeroMemory( &remproc, sizeof(remproc) );

	countblock=_wtoi(mainmsg);

	tableWidget->setColumnCount(3); // 
	tableWidget->setRowCount(countblock); //
	//tableWidget->verticalHeader()->hide();
	QStringList mycolumns;
	mycolumns<<" "<<"PID"<<"";
	tableWidget->setHorizontalHeaderLabels(mycolumns);
	tableWidget->setSortingEnabled(false);

	for (int i=0;i<countblock;i++)		
	{ 
		DWORD dwErr = GetLastError();
		if ( dwErr == ERROR_NO_DATA)
			break;

		fSuccess = ReadFile( 
			hPipe,    // pipe handle 
			&remproc,    // buffer to receive reply 
			sizeof(remproc),  // size of buffer 
			&cbRead,  // number of bytes read 
			NULL);    // not overlapped 

		ProcessList.clear();
		ProcessList<<QString::fromStdWString(remproc.NAME);
		ProcessList<<QString::number(remproc.ProcessPid);
		ProcessList<<QString::fromStdWString(remproc.USER);


		for (column=0;column<tableWidget->columnCount();column++)
		{
			QString name = ProcessList.at(column);
			QTableWidgetItem *newItem = new QTableWidgetItem(name);
			tableWidget->setItem(row, column, newItem);
		}
row++;


		if (! fSuccess && GetLastError() != ERROR_MORE_DATA) 
			break; 
	} 

	CloseHandle(hPipe);

	tableWidget->resizeRowsToContents();
	//tableWidget->resizeColumnsToContents();
	tableWidget->horizontalHeader()->setStretchLastSection(true);
	tableWidget->horizontalHeader()->setHighlightSections(false);
	tableWidget->setCurrentCell(0,0);
	tableWidget->setSortingEnabled(true);


}

